from dmu_utils.misc import identity_func


def deep_update(base_dict, update_with):
    for key, value in update_with.items():
        if isinstance(value, dict):
            base_dict_value = base_dict.get(key)
            if isinstance(base_dict_value, dict):
                deep_update(base_dict_value, value)
            else:
                base_dict[key] = value
        else:
            base_dict[key] = value

    return base_dict


def set_if(dict_, key, value, if_callable=identity_func):
    if if_callable(value):
        dict_[key] = value
